<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>UserActionController.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">vendingmachine</a> &gt; <a href="index.source.html" class="el_package">com.example.vendingmachine.controller</a> &gt; <span class="el_source">UserActionController.java</span></div><h1>UserActionController.java</h1><pre class="source lang-java linenums">package com.example.vendingmachine.controller;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import com.example.vendingmachine.component.VirtualVendingMachine;
import com.example.vendingmachine.entity.Coin;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import jakarta.validation.Valid;
import jakarta.validation.constraints.NotEmpty;

@RestController
<span class="fc" id="L21">public class UserActionController {</span>

    @Autowired
    VirtualVendingMachine virtualVendingMachine;

    @PostMapping(&quot;/user-actions/coins&quot;)
    @Operation(summary = &quot;insert coin to the vending machine&quot;, description = &quot;Accept only the coins: _10ST, _20ST, _50ST, _1LV, _2LV&quot;)
    @ApiResponses(value = {
            @ApiResponse(responseCode = &quot;200&quot;, description = &quot;Inserted coin _20ST and current amount is: 2.20&quot;)
    })
    public String insertCoin(@Valid @NotEmpty @RequestBody Coin coin) {
<span class="fc" id="L32">        virtualVendingMachine.insertCoin(coin);</span>
<span class="fc" id="L33">        return virtualVendingMachine.getCurrentOuptut();</span>
    }

    @DeleteMapping(&quot;/user-actions/coins&quot;)
    @Operation(summary = &quot;reset the vending machine&quot;, description = &quot;If there are coins in the vending machine will be returned&quot;)
    public String reset() {
<span class="fc" id="L39">        virtualVendingMachine.reset();</span>
<span class="fc" id="L40">        return virtualVendingMachine.getCurrentOuptut();</span>
    }

    @GetMapping(&quot;/user-actions/products/{id}&quot;)
    @Operation(summary = &quot;buy product&quot;, description = &quot;Select product from the vending machine&quot;)
    public String buyProduct(@Valid @NotEmpty @PathVariable long id) {
<span class="fc" id="L46">        virtualVendingMachine.buyProductById(id);</span>
<span class="fc" id="L47">        return virtualVendingMachine.getCurrentOuptut();</span>
    }

}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.8.202204050719</span></div></body></html>